/*
 * increment
 * by Joel R. Voss
 * Jan 29, 2006
 * Increment a word of text. Used for brute force password crackers.
 */

#include <stdio.h>
#include <string.h>
#include "increment.h"

void increment(const char *input, int size, char *output, char start, char end, int hex)
{
	int i;
	//output[size] = 0;
	for(i = size - 1; i >= 0; i--)
	{
		if(input[i] == end)
		{
			//fprintf(stderr, "e\n");
			output[i] = start;
		}
		else
		{
			//fprintf(stderr, "i\n");
			if(hex && (input[i] == '9'))
			{
				// In Hexadecimal, a comes after 9.
				output[i] = 'a';
			}
			else
			{
				output[i] = input[i] + 1;
			}
			i--;
			break;
		}
	}
	for(; i >= 0; i--)
	{
		//fprintf(stderr, "s\n");
		output[i] = input[i];
	}
}

#ifdef __INC_SA__
int main(int argc, char **argv)
{
	if(argc < 2)
	{
		printf("Usage: increment [-x] blah [a] [z]\n"
				"Output: blai\n");
		return 1;
	}
	// Go all the way from <space> to ~ for strong passwords.
	char start = 32; // <space>
	char end = 126; // ~
	char hex = 0;
	char *argv1 = argv[1];
	if(argc >= 3)
	{
		if(strncmp(argv[1], "-x", 2) == 0)
		{
			// Hexadecimal!
			hex = 1;
			start = '0';
			end = 'f';
			argv1 = argv[2];
		}
		else
		{
			start = argv[2][0];
		}
	}
	if(argc >= 4)
	{
		end = argv[3][0];
	}
	int size = strlen(argv1);
	char output[size+1];
	increment(argv1, size, output, start, end, hex);
	printf("%s\n", output);
	return 0;
}
#endif // __INC_SA__
