/*
 * RSA Private key Cracker
 * by Javantea
 * May 8, 2007
 *
 */

/*
 * Description: This simple RSA cracker takes an encrypted private key in pem 
 * format and tries to decrypt it. When it finds one, it gives up. It could 
 * easily be optimized for better performance. This beta version tries 
 * 000 -> ~~~ in 38 seconds on a P4. 79 chars ^ 3 = 493039. 12974.7 tests per 
 * second. John gets 683117 *sigh*. There's a lot of performance to gain.
 * OpenSSL provides very easy lower level interfaces to these things so that I 
 * won't have to do much more than Decrypt() Check() inside the while loop.
 */

#include <openssl/pem.h>
#include <openssl/err.h>
#include <openssl/evp.h>
#include <increment.h>
#include <string.h>

// The same increment function from bf_brute-0.2. Muhahaha.
// increment(const char *input, int size, char *output, char start, char end, int hex);

//#ifdef __RSA_BRUTE_SA__

void usage()
{
	printf("Usage: rsa_brute octal2.pem [mypass000]\n");
}

int main(int argc, char **argv)
{
	if(argc < 2 || (strncmp(argv[1], "-h", 2) == 0))
	{
		usage();
		return 1;
	}
	// Segfault in increment if I don't use this odd system. *shrug*
	char default_pw[5];
	strncpy(default_pw, "0000", 5);
	char *password = default_pw;
	if(argc >= 3)
	{
		password = argv[2];
	}
	int pass_len = strlen(password);
	
	// This is what makes it happen!
	OpenSSL_add_all_ciphers();
	FILE *infile;
	int cracked = 0;
	int tries = 0;
	
	// Ah yes, the perfect while loop.
	while(cracked < 1)
	{
		// Reload the file each time, this can be sped up.
		infile = fopen(argv[1], "rb");
		if(infile == 0)
		{
			printf("File is invalid: %s\n", argv[1]);
			usage();
			return 1;
		}
		
		// Try to read the key.
		EVP_PKEY *key;
		key = PEM_read_PrivateKey(infile, NULL, NULL, password);
		//printf("Private key: %08x\n", key);
		/*if(key == 0) {
			ERR_print_errors_fp(stdout);
		}*/
		// The file isn't needed.
		fclose(infile);
		
		// We have a possible working password.
		if(key != 0) {
			RSA *rsa = EVP_PKEY_get1_RSA(key);
			if(rsa == 0) {
				printf("This is not an rsa key. It's something else.\n");
			}
			printf("Possible match with password: %s\n", password);
			cracked++;
			
			if(rsa != 0) {
				RSA_free(rsa);
			}
		}
		
		if(key != 0) {
			EVP_PKEY_free(key);
		}
		tries++;
		increment(password, pass_len, password, '0', '~', 0);
		if(strlen(password) >= 3 && strcmp(&(password[strlen(password)-3]), "000") == 0)
			printf("trying:%s\n", password);
	}
	
	/*
	// Test Cipher loading.
	const EVP_CIPHER *enc = EVP_get_cipherbyname("AES-256-CBC");
	printf("Cipher: %08x\n", enc);
	if(enc == 0) {
		ERR_print_errors_fp(stdout);
	}
	*/
	// This is good coding practice.
	EVP_cleanup();
	
	return 0;
}


//#endif // __RSA_BRUTE_SA__
